/*
 *  Toppers/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: configurator.cpp,v 1.7 2001/05/07 07:23:44 takayuki Exp $
 */

// Configurator.cpp : 󥽡 ץꥱѤΥȥ ݥȤ
//

#define APPNAME "Configurator"

#include "manager.h"
#include "simpleparser.h"
#include "exception.h"
#include <stdio.h>
#include <stdlib.h>

int main(int argc, char* argv[])
{
	Manager mainapp(new SimpleParser);
	char * sourcefilename = NULL;
	int i;
	
	for(i=1;i<argc;i++)
	{
		if( *(argv[i]) == '-')
		{
			switch(*(argv[i]+1))
			{
			case 'O':
				mainapp.SetOption(Manager::CREATEORTIFILE);
				break;

			case '-':
				if( strcmp(argv[i]+2, "odl") == 0)
				{
					mainapp.SetOption(Manager::CREATEORTIFILE);
					break;
				}
				
			default:
				fprintf(stderr, MSG_UNKNOWNOPTION "\n", argv[i]);	
				return EXIT_FAILURE;
			}
		}else
		{
			if(sourcefilename == NULL)
				sourcefilename = argv[i];
			else{
				fputs(MSG_ALREADYGIVENSRCFILE "\n",stderr);
				return EXIT_FAILURE;
			}
		}
	}

	try
	{
		mainapp.Body(sourcefilename);
	}
	catch(Exception e)
	{
		fputs("Program was aborted with fatal errors\n",stderr);
		fputs(e,stderr);
		fputc('\n',stderr);
	}
	return EXIT_SUCCESS;
}
