/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: staticapi.cpp,v 1.4 2001/02/23 16:52:17 takayuki Exp $
 */

#include "staticapi.h"

char * StaticAPI::CheckParameter_Primitive(Array * param, char * format)
{
	int position;
	Valient * work;
	unsigned int flag;

	position = 0;
	flag = 0;
	while(true)
	{
		switch(*format)
		{
		case '{':
			if(!param->IsArray(position))
				throw Exception(MSG_ILLEGALTYPE);

			if((format = CheckParameter_Primitive(param->GetArrayPtr(position),format+1)) == '\x0')
				throw Exception(MSG_INTERNAL " : " MSG_SYNTAXERROR);

			if(*format == '\x0')
				return 0l;
			position ++;
			break;
		
		case '}':
		case ',':
		case '\x0':
			work = param->GetValuePtr(position);
			if(work == 0l)
				throw Exception(MSG_TOOFEWPARAM);
			
			if((flag & (1 << (int)work->GetType())) == 0)
				throw Exception(MSG_ILLEGALTYPE);
			
			if( *format == '}' )
				return format+1;
			if( *format == '\x0' )
				return 0l;

			flag = 0;
			position ++;
			break;

		case '-':
			flag |= ~0;
			break;

		case 'S':
		case 's':
			flag |= 1 << Valient::STRING;
			break;
		case 'I':
		case 'i':
			flag |= 1 << Valient::INTEGER;
			break;
		case 'D':
		case 'd':
			flag |= 1 << Valient::DOUBLE;
			break;
		case 'U':
		case 'u':
			flag |= 1 << Valient::UNSIGNEDINTEGER;
			break;
		case 'P':
		case 'p':
			flag |= 1 << Valient::POINTER;
			break;
		default:
			throw Exception(MSG_INTERNAL " : " MSG_SYNTAXERROR);
		}

		format ++;
	}
}
