/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: valient.h,v 1.3 2000/11/14 16:57:33 takayuki Exp $
 */

//----------------------------------------------------------------
// class Valient - class definition
//

#ifndef __VALIENT_H
#define __VALIENT_H

class Valient
{
public:
	enum tagType
	{
		EMPTY, INTEGER, UNSIGNEDINTEGER, DOUBLE, STRING, POINTER
	};

protected:
	enum tagType Type;
	union
	{
		int Integer;
		unsigned int UnsignedInteger;
		double Double;
		struct
		{
			unsigned int Size;
			char * Entity;
		} String;
		void * Pointer;
	};

public:
	Valient(void);
	Valient(int);
	explicit Valient(unsigned int);
	Valient(double);
	explicit Valient(char *);
	Valient(void *);
	Valient(const Valient &);

	virtual ~Valient(void);

	bool Set(int);
	bool Set(unsigned int);
	bool Set(double);
	bool Set(char *);
	bool Set(void *);

	int GetInteger(int =0);
	char * GetString(char * =0l);
	double GetDouble(double =0.0);
	void * GetPointer(void * =0l);

	bool Clear(void);

	enum tagType GetType(void);

	bool operator ==(enum tagType);
	char * operator =(char *);
	Valient & operator =(const Valient &);

	operator const enum tagType(void)
	{	return Type;	};
};

inline Valient::Valient(void)
{	Type=EMPTY;	}

inline Valient::Valient(int src)
{	Type=EMPTY;	this->Set(src);	}

inline Valient::Valient(unsigned int src)
{	Type=EMPTY;	this->Set(src);	}

inline Valient::Valient(double src)
{	Type=EMPTY;	this->Set(src);	}

inline Valient::Valient(char * src)
{	Type=EMPTY;	this->Set(src);	}

inline Valient::Valient(void * src)
{	Type=EMPTY;	this->Set(src);	}

inline bool Valient::operator ==(enum tagType src)
{	return Type == src;	}

inline char * Valient::operator =(char * src)
{
	Set(src);
	return src;
}

inline int Valient::GetInteger(int def)
{
	if(Type != INTEGER)
		return def;
	return Integer;
}

inline char * Valient::GetString(char * def)
{
	if(Type != STRING)
		return def;
	return String.Entity;
}

inline double Valient::GetDouble(double def)
{
	if(Type != DOUBLE)
		return def;
	return Double;
}

inline void * Valient::GetPointer(void * def)
{
	if(Type != POINTER)
		return def;
	return Pointer;
}

inline enum Valient::tagType Valient::GetType(void)
{	return Type;	}

#endif

//--------
// Designed and Programmed by S.D.F.