/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 *
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: cpu_config.c,v 1.1 2001/05/04 09:07:50 imai Exp $
 */


#include "jsp_kernel.h"
#include "check.h"
#include "task.h"

#include "sh1.h"

/*
 *  ץå¸⥸塼SH1ѡ
 */

/*
 *  ƥȤǤγߥޥ
 */
#ifdef SUPPORT_CHG_IPM
UW	task_intmask;
#endif /* SUPPORT_CHG_IPM */

/*
 *  󥿥ƥȤǤγߥޥ
 */
UW	int_intmask;

/*
 *  ߡCPU㳰ͥȥ
 */
UW	intnest;


/*
 *  㳰٥ơ֥
 */
#ifdef EXCVT_KERNEL
EXCVE BASE_VBR[EXCVT_SIZE];
#endif	/*  EXCVT_KERNEL  */


/*
 *  ץå¸ν
 */
void
cpu_initialize()
{
	/*
	 *  ƥȤǤγߥޥν
	 */
#ifdef SUPPORT_CHG_IPM
	task_intmask = 0x0000;
#endif /* SUPPORT_CHG_IPM */

	/*
	 *  ߡCPU㳰ͥȥ󥿤ν
	 */
	intnest = 0;

#ifndef WITH_STUB

	/*
	 * ߥȥν
	 */
	*IPRA = 0x0000;
	*IPRB = 0x0000;
	*IPRC = 0x0000;
	*IPRD = 0x0000;
	*IPRE = 0x0000;

#endif	/*  WITH_STUB  */

#ifdef EXCVT_KERNEL
	/*
	 *  ٥ơ֥ν
	 */
	{
		FP *src, *dst, *end;

		src = (FP *)EXCVT_ORIG;
		dst = (FP *)EXCVT_KERNEL;
		end = dst + EXCVT_LEN;

		while (dst != end) {
			*dst++ = *src++;
		}
	}
	/*
	 *  ٥١쥸ν
	 */
	set_vbr(EXCVT_KERNEL);
#endif /* EXCVT_KERNEL */

}



/*
 *  ץå¸νλ
 */
void
cpu_terminate()
{
#ifdef EXCVT_KERNEL
	set_vbr(EXCVT_ORIG);
#endif /* EXCVT_KERNEL */
}

#ifdef SUPPORT_CHG_IPM

/*
 *  ߥޥѹ
 *
 *  chg_ipm Ȥä IPM  MAX_IPM NMI ֥⡼ȥ֥졼 ʳ
 *  Τ٤Ƥγߤػߡ˰ʾѹ뤳ȤϤǤʤNMI ֥
 *  ⡼ȥ֥졼ʳΤ٤Ƥγߤػߤˤϡloc_cpu 
 *  CPUå֤ˤФ褤IPM  0 ʳλˤ⡤ǥ
 *  ѥåαʤIPM ϡǥѥåˤäơ
 *  Ծ֤ˤʤäذѤ롥Τᡤ¹ˡ
 *  Υˤä IPM ѹ礬롥JSPͥǤϡIPM
 *  ѹϥ㳰롼ˤäƤⵯΤǡˤäư
 *  񤷤ʤϾʤȻפ롥IPM ͤˤäƥǥ
 *  ѥåػߤˤϡdis_dsp ʻѤФ褤
 */

SYSCALL ER
chg_ipm(IPM ipm)
{
	CHECK_TSKCTX_UNL();
	CHECK_PAR(0 <= ipm && ipm <= MAX_IPM - 1);

	t_lock_cpu();
	task_intmask = (ipm << 4);
	t_unlock_cpu();
	return(E_OK);
}

/*
 *  ߥޥλ
 */
SYSCALL ER
get_ipm(IPM *p_ipm)
{
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	*p_ipm = (task_intmask >> 4);
	t_unlock_cpu();
	return(E_OK);
}


#endif /* SUPPORT_CHG_IPM */


/*
 * ϿƤʤ㳰ȯȸƤӽФ
 */
void cpu_experr(EXCSTACK *sp)
{
    syslog(LOG_EMERG, "Exception error occurs.");

    syslog(LOG_EMERG, "PC = %08x SR = %08x PR = %08x",
    			sp->pc, sp->sr, sp->pr);

    syslog(LOG_EMERG, "r0 = %08x r1 = %08x r2 = %08x",
    			sp->r0, sp->r1, sp->r2);
    syslog(LOG_EMERG, "r3 = %08x r4 = %08x r5 = %08x",
    			sp->r3, sp->r4, sp->r5);
    syslog(LOG_EMERG, "r6 = %08x r7 = %08x r8 = %08x",
    			sp->r6, sp->r7, sp->r8);
    syslog(LOG_EMERG, "r9 = %08x r10 = %08x r11 = %08x",
    			sp->r9, sp->r10, sp->r11);
    syslog(LOG_EMERG, "r12 = %08x r13 = %08x r14 = %08x",
    			sp->r12, sp->r13, sp->r14);
    			/*  㳰ȯľΥåݥ󥿤  */
    syslog(LOG_EMERG, "r15 = %08x", (sp->r15)+19*4);

    while(1);
}
