/*
 *  TOPPERS/JSP Kernel
 *	Toyohashi Open Platform for Embedded Real-Time Systems/
 *	Just Standard Profile Kernel
 *
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *	ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *	˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *	ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *	  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *	  ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *	⡤嵭Ԥդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 *
 *  @(#) $Id: hw_timer.h,v 1.1 2001/05/04 09:07:50 imai Exp $
 */

#ifndef _HW_TIMER_H_
#define _HW_TIMER_H_

/*
 *  CPU¸ޥ⥸塼SH1ѡ
 *  TMU0
 */

#include "sh1.h"
#include "sys_defs.h"
#include "cpu_config.h"

/*
 *  ޳ߥϥɥΥ٥ֹ
 *	jsp/systask/timer.cfgǳߥϥɥϿ˻
 */
#define	INHNO_TIMER	IMIA0

/*
 *  ͤɽη
 */
typedef UH	CLOCK;

/*
 *  ޡγߥ٥
 */
#define TINTLVL0	4

/*  ߥ٥쥸ȤΥեȿ  */
#define ITU_BIT_SHIFT	4

/*
 *  ޼ñ̤ɽѴ
 *  	jsp/kernel/time_manage.cǤ
 */
#define TO_CLOCK(nume, deno)	(TIMER_CLOCK * (nume) / (deno))

/*
 *  ޼ñ̤ɽѴ
 */
#define CLOCK_PER_TICK	((CLOCK) TO_CLOCK(TIC_NUME, TIC_DENO))

/*
 *  ǤΥ޼ñ̤ɽ
 */
#define MAX_CLOCK	((CLOCK) 0xffff)

/*
 *  ǽɾѥƥФݤν֤θѤ
 *	ñ̤ɽ
 *	աʬå˰¸
 */
#define GET_TOLERANCE	100


/*
 *  ޳׵Υꥢ
 *	TCR쥸IMFAӥåȤ1ɤ߽Фˣ񤭹
 */


Inline void
hw_timer_int_clear()
{
    ITU.TSR0 &= ~TSR_IMFA;	/* ׵򥯥ꥢ 	*/
}				/*  GRAڥޥåե饰 */


/*
 *  ޤεư
 *
 *  ޤŪʥ޳׵ȯ롥
 */
Inline void
hw_timer_initialize()
{
	/*
	 *  ޴Ϣ
	 */
    ITU.TSTR &= ~TSTR_STR0;	/*  */
    		     		/* ޾ͤΥå */
    assert(CLOCK_PER_TICK <= MAX_CLOCK);
			/*  GRAڥޥåǥ󥿤򥯥ꥢ */
			/*  ʬ  			*/
    ITU.TCR0 = (TCR_CCLR_GRA | TCR_TPSC);
			/*  GRAڥޥåˤ׵ */
    ITU.TIER0 = TIER_RESERVE | TIER_IMIEA;
			/*  GRAڥޥåˤüҽ϶ػ */
    ITU.TIOR0 = TIOR_RESERVE | TIOR_IOA;
			/*  GRA쥸ʥɸ͡  	*/
    ITU.GRA0 = CLOCK_PER_TICK;
    ITU.TCNT0 = 0;	/* 󥿤򥯥ꥢ 			*/

	/*
	 *  ߴϢ
	 */
    					/* ߥ٥ 	*/
    define_int_plevel(IPRC, TINTLVL0, ITU_BIT_SHIFT);
    hw_timer_int_clear();		/*  ׵򥯥ꥢ  */


    ITU.TSTR  |= TSTR_STR0;		/* ޥ    	*/
}


/*
 *  ޤ߽
 */
Inline void
hw_timer_terminate()
{
    ITU.TSTR &= ~TSTR_STR0;		  /* ޤ 	  */
    hw_timer_int_clear();		  /* ׵򥯥ꥢ */
}

/*
 *  ޤθͤɤ߽Ф
 *
 *  ߶ػ߶ǸƤӽФȡ
 */
Inline CLOCK
hw_timer_get_current(void)
{
	return(CLOCK_PER_TICK - (CLOCK)(ITU.TCNT0));
}

/*
 *  ޳׵Υå
 */
Inline BOOL
hw_timer_fetch_interrupt(void)
{
	return(ITU.TSR0 & TSR_IMFA);
}

#endif /* _HW_TIMER_H_ */
