/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000,2001 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: cpu_config.c,v 1.7 2001/02/23 21:14:08 honda Exp $
 */


#include "jsp_kernel.h"
#include "check.h"
#include "task.h"

#include "sh3.h"

/*
 *  ץå¸⥸塼SH3ѡ
 */

/*
 *  ƥȤǤγߥޥ
 */
#ifdef SUPPORT_CHG_IPM
UW	task_intmask;
#endif /* SUPPORT_CHG_IPM */

/*
 *  󥿥ƥȤǤγߥޥ
 */
UW	int_intmask;


/*
 * ߥϥɥ/ͥ٤εơ֥
 */
FP  int_table[0x50];
VW  int_plevel_table[0x50];

/*
 * CPU㳰ϥɥεơ֥
 */
FP	exc_table[(0x1E0 >> 5) + 1];

/*
 *  ץå¸ν
 */
void
cpu_initialize()
{
    /*
     *  ƥȤǤγߥޥν
     */
#ifdef SUPPORT_CHG_IPM
    task_intmask = 0x0000;    
#endif /* SUPPORT_CHG_IPM */

#ifndef WITH_STUB
    /*
     * ߥȥν 
     */
    *ICR0 = 0x0000;
    *IPRA = 0x0000;     
    *IPRB = 0x0000;
    
#ifndef SH7708    
    *ICR1 = 0x0000;
    *ICR2 = 0x0000;     
    *PINTER = 0x0000;
    *IPRC = 0x0000;
    *IPRD = 0x0000;
    *IPRE = 0x0000;
    *IRR0 = 0x0000;   
    *IRR1 = 0x0000;
    *IRR2 = 0x0000;
#endif
    
    /*
     *  ٥١쥸ν
     */
    set_vbr(BASE_VBR);
#endif

}



/*
 *  ץå¸νλ
 */
void
cpu_terminate()
{
}


/*
 * Trapaʳ㳰ϿƤʤ㳰ȯȸƤӽФ
 */
void cpu_expevt(VW expevt,VW spc,VW ssr,VW pr)
{
    syslog(LOG_EMERG, "Expevt error occurs.");

    syslog(LOG_EMERG, "Expevt = %08x SPC = %08x SR = %08x PR=%08X",expevt,spc,
             ssr,pr);
    while(1);
    exit();
}

#ifdef SUPPORT_CHG_IPM

/*
 *  ߥޥѹ
 *
 *  chg_ipm Ȥä IPM  MAX_IPM NMI ֥⡼ȥ֥졼 ʳ
 *  Τ٤Ƥγߤػߡ˰ʾѹ뤳ȤϤǤʤNMI ֥
 *  ⡼ȥ֥졼ʳΤ٤Ƥγߤػߤˤϡloc_cpu 
 *  CPUå֤ˤФ褤IPM  0 ʳλˤ⡤ǥ
 *  ѥåαʤIPM ϡǥѥåˤäơ
 *  Ծ֤ˤʤäذѤ롥Τᡤ¹ˡ
 *  Υˤä IPM ѹ礬롥JSPͥǤϡIPM
 *  ѹϥ㳰롼ˤäƤⵯΤǡˤäư
 *  񤷤ʤϾʤȻפ롥IPM ͤˤäƥǥ
 *  ѥåػߤˤϡdis_dsp ʻѤФ褤
 */

SYSCALL ER
chg_ipm(IPM ipm)
{
	CHECK_TSKCTX_UNL();
	CHECK_PAR(0 <= ipm && ipm <= MAX_IPM - 1);

	t_lock_cpu();
	task_intmask = (ipm << 4);
	t_unlock_cpu();
	return(E_OK);
}

/*
 *  ߥޥλ
 */
SYSCALL ER
get_ipm(IPM *p_ipm)
{
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	*p_ipm = (task_intmask >> 4);
	t_unlock_cpu();
	return(E_OK);
}


            



#endif /* SUPPORT_CHG_IPM */








