/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: hw_serial.c,v 1.1 2000/11/14 16:31:38 takayuki Exp $
 */
#include "hw_serial.h"


extern HANDLE PrimaryThreadHandle;

/*
 * ꥢ()ǥХν
 */

BOOL
hw_port_initialize(HWPORT *p)
{
	if(p->Handle != INVALID_HANDLE_VALUE)
		CloseHandle(p->Handle);

	if( (p->Flag & SIO_SERVER) != 0)
	{
		p->Handle = CreateNamedPipe(p->DeviceName,PIPE_ACCESS_DUPLEX|FILE_FLAG_OVERLAPPED,PIPE_TYPE_BYTE|PIPE_NOWAIT,PIPE_UNLIMITED_INSTANCES,2048,2048,0,NULL);
	}else
	{
		p->Handle = CreateFile(p->DeviceName,GENERIC_READ|GENERIC_WRITE,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	}
	if(p->Handle != INVALID_HANDLE_VALUE)
	{
		SetTimer(PrimaryThreadHandle,(0xffff0000|INHNO_SERIAL),100,NULL);
		return FALSE;
	}
	return TRUE;
}

/*
 * ꥢ()ǥХΥåȥ
 */

void
hw_port_terminate(HWPORT *p)
{
	if(p->Handle != INVALID_HANDLE_VALUE)
	{
		CloseHandle(p->Handle);
		p->Handle = INVALID_HANDLE_VALUE;
	}
}

/*
 *  ʸ
 */
BOOL
hw_port_getready(HWPORT *p)
{
	DWORD charinbuf;
	if((p->Flag & SIO_PIPE) != 0)
	{
		PeekNamedPipe(p->Handle,NULL,0,NULL,&charinbuf,NULL);
		return (charinbuf != 0) ? TRUE : FALSE;
	}
	return FALSE;
}

/*
 *  ʸǤ뤫
 */
BOOL
hw_port_putready(HWPORT *p)
{
		/*񤤤ƤߤʤȤ狼ʤΤǾ˽񤱤Ƚ*/
	return TRUE;
}

/*
 *  ʸμФ
 */
byte
hw_port_getchar(HWPORT *p)
{
	DWORD chars;
	char Buffer;
	ReadFile(p->Handle,&Buffer,1,&chars,NULL);
    return Buffer;
}

/*
 *  ʸν񤭹
 */
void
hw_port_putchar(HWPORT *p, byte c)
{
	DWORD chars;
	WriteFile(p->Handle,&c,1,&chars,NULL);
}

/*
 *  ؿ
 */
void
hw_port_sendstart(HWPORT *p)
{}

void
hw_port_sendstop(HWPORT *p)
{}

