/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: sys_manage.c,v 1.1 2000/11/14 14:44:21 hiro Exp $
 */

/*
 *	ƥִǽ
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"

/*
 *  ̤ͥβž
 */
SYSCALL ER
rot_rdq(PRI tskpri)
{
	UINT	pri;

	CHECK_TSKCTX_UNL();
	CHECK_TPRI_SELF(tskpri);

	t_lock_cpu();
	pri = (tskpri == TPRI_SELF) ? runtsk->priority : INT_PRIORITY(tskpri);
	if (rotate_ready_queue(pri)) {
		dispatch();
	}
	t_unlock_cpu();
	return(E_OK);
}

/*
 *  ̤ͥβž󥿥ƥѡ
 */
SYSCALL ER
irot_rdq(PRI tskpri)
{
	CHECK_INTCTX_UNL();
	CHECK_TPRI(tskpri);

	i_lock_cpu();
	if (rotate_ready_queue(INT_PRIORITY(tskpri))) {
		reqflg = TRUE;
	}
	i_unlock_cpu();
	return(E_OK);
}

/*
 *  ¹Ծ֤ΥIDλ
 */
SYSCALL ER
get_tid(ID* p_tskid)
{
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	*p_tskid = TSKID(runtsk);
	t_unlock_cpu();
	return(E_OK);
}

/*
 *  ¹Ծ֤ΥIDλȡ󥿥ƥѡ
 */
SYSCALL ER
iget_tid(ID* p_tskid)
{
	CHECK_INTCTX_UNL();

	i_lock_cpu();
	*p_tskid = (runtsk == NULL) ? TSK_NONE : TSKID(runtsk);
	i_unlock_cpu();
	return(E_OK);
}

/*
 *  CPUå֤ؤΰܹ
 */
SYSCALL ER
loc_cpu(void)
{
	CHECK_TSKCTX();

	if (!(t_sense_lock())) {
		t_lock_cpu();
	}
	return(E_OK);
}

/*
 *  CPUå֤ؤΰܹԡ󥿥ƥѡ
 */
SYSCALL ER
iloc_cpu(void)
{
	CHECK_INTCTX();

	if (!(i_sense_lock())) {
		i_lock_cpu();
	}
	return(E_OK);
}

/*
 *  CPUå֤β
 *
 *  CPUåϡǥѥåɬפȤʤ륵ӥƤӽФ
 *  ȤϤǤʤᡤCPUå֤β˥ǥѥåư
 *  ɬפϤʤ
 */
SYSCALL ER
unl_cpu(void)
{
	CHECK_TSKCTX();

	if (t_sense_lock()) {
		t_unlock_cpu();
	}
	return(E_OK);
}

/*
 *  CPUå֤β󥿥ƥѡ
 *
 *  CPUåϡǥѥåɬפȤʤ륵ӥƤӽФ
 *  ȤϤǤʤᡤCPUå֤β˥ǥѥåεư
 *  ᤹ɬפϤʤ
 */
SYSCALL ER
iunl_cpu(void)
{
	CHECK_INTCTX();

	if (i_sense_lock()) {
		i_unlock_cpu();
	}
	return(E_OK);
}

/*
 *  ǥѥåζػ
 */
SYSCALL ER
dis_dsp(void)
{
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	enadsp = FALSE;
	t_unlock_cpu();
	return(E_OK);
}

/*
 *  ǥѥåε
 */
SYSCALL ER
ena_dsp(void)
{
	CHECK_TSKCTX_UNL();

	t_lock_cpu();
	enadsp = TRUE;
	if (runtsk != schedtsk) {
		dispatch();
	}
	t_unlock_cpu();
	return(E_OK);
}

/*
 *  ƥȤλ
 */
SYSCALL BOOL
sns_ctx()
{
	return(sense_context() ? TRUE : FALSE);
}

/*
 *  CPUå֤λ
 */
SYSCALL BOOL
sns_loc()
{
	return(sense_lock() ? TRUE : FALSE);
}

/*
 *  ǥѥåػ߾֤λ
 */
SYSCALL BOOL
sns_dsp()
{
	return(!(enadsp) ? TRUE : FALSE);
}

/*
 *  ǥѥåα֤λ
 */
SYSCALL BOOL
sns_dpn()
{
	return((sense_context() || sense_lock() || !(enadsp)) ? TRUE : FALSE);
}
