/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: serial.c,v 1.2 2000/12/13 01:01:56 hiro Exp $
 */

/*
 *	ꥢ륤󥿥եɥ饤
 */

#include <jsp_services.h>
#include "kernel_id.h"

/*
 *  ꥢ륤󥿥եɥ饤Фεư
 */

static BOOL	in_inirtn = FALSE;	/* 롼¹򼨤 */

void
serial_initialize(VP_INT portid)
{
	in_inirtn = TRUE;
	syscall(serial_open((ID) portid));
	in_inirtn = FALSE;
	syslog(LOG_NOTICE, "Serial driver service starts on port %d.", portid);
}

/*
 *  ꥢݡȴ֥å
 */

#define	SERIAL_BUFSZ	256	/* ꥢ륤󥿥եѥХåեΥ */

#define	inc(x)		(((x)+1 < SERIAL_BUFSZ) ? (x)+1 : 0)
#define	INC(x)		((x) = inc(x))

typedef struct serial_port_control_block {
	BOOL	init_flag;	/* Ѥ */
	HWPORT	hwport;		/* ϡɥ¸ */
	ID	in_semid;	/* Хåեѥޥե ID */
	ID	out_semid;	/* Хåեѥޥե ID */

	int	in_read_ptr;	/* Хåեɤ߽Фݥ */
	int	in_write_ptr;	/* Хåե񤭹ߥݥ */
	int	out_read_ptr;	/* Хåեɤ߽Фݥ */
	int	out_write_ptr;	/* Хåե񤭹ߥݥ */
	UINT	ioctl;		/* ioctl ˤ */
	BOOL	send_enabled;	/* 򥤥֥͡뤷Ƥ뤫 */
	BOOL	ixon_stopped;	/* STOP ä֤ */
	BOOL	ixoff_stopped;	/*  STOP ä֤ */
	char	ixoff_send;	/*  START/STOP 뤫 */

	char	in_buffer[SERIAL_BUFSZ];	/* Хåեꥢ */
	char	out_buffer[SERIAL_BUFSZ];	/* Хåեꥢ */
} SPCB;

#define	IN_BUFFER_EMPTY(spcb) \
		((spcb)->in_read_ptr == (spcb)->in_write_ptr)
#define	IN_BUFFER_FULL(spcb) \
		((spcb)->in_read_ptr == inc((spcb)->in_write_ptr))
#define	OUT_BUFFER_FULL(spcb) \
		((spcb)->out_read_ptr == inc((spcb)->out_write_ptr))

/*
 *  ⥸塼ǻȤؿ
 */
static BOOL	serial_getc(SPCB *spcb, char *c);
static BOOL	serial_putc(SPCB *spcb, char c);

/*
 *  ꥢݡȴ֥åȽ
 */

SPCB spcb_table[NUM_PORT] = {
	{ 0, HWPORT1, SEM_SERIAL1_IN, SEM_SERIAL1_OUT },
#if NUM_PORT > 1
	{ 0, HWPORT2, SEM_SERIAL2_IN, SEM_SERIAL2_OUT },
#endif
};

#define get_spcb(portid)	(&(spcb_table[(portid)-1]))
#define get_spcb_def(portid)	get_spcb((portid) ? (portid) : CONSOLE_PORTID)

/*
 *  ݡȤΥץ
 *
 *  ʣΥƱ˸Ƥ־ˤбƤʤ
 */
ER
serial_open(ID portid)
{
	SPCB	*spcb;
	ER	ercd;

	if (!(1 <= portid && portid <= NUM_PORT)) {
		return(E_ID);
	}
	spcb = get_spcb(portid);

	if (spcb->init_flag) {		/* ѤΥå */
		return(E_OK);
	}

	/*
	 *  ѿν
	 */
	spcb->in_read_ptr = spcb->in_write_ptr = 0;
	spcb->out_read_ptr = spcb->out_write_ptr = 0;
	spcb->ioctl = (IOCTL_ECHO | IOCTL_CRLF | IOCTL_CANONICAL
				| IOCTL_IXON | IOCTL_IXOFF);
	spcb->send_enabled = FALSE;
	spcb->ixon_stopped = spcb->ixoff_stopped = FALSE;
	spcb->ixoff_send = 0;

	/*
	 *  ϡɥ¸ν
	 */
	if (!in_inirtn) {
		syscall(loc_cpu());
	}
	if (hw_port_initialize(&(spcb->hwport))) {
		ercd = E_SYS;
	}
	else {
		spcb->init_flag = TRUE;
		ercd = E_OK;
	}
	if (!in_inirtn) {
		syscall(unl_cpu());
	}
	return(ercd);
}

/*
 *  ݡȤΥ
 *
 *  flush  TRUE ξϡꥢݡȤؤХåեˤʤ
 *  Ԥġ
 *  ʣΥƱ˸Ƥ־ˤбƤʤ
 */

#define	MAX_FLUSH_LOOP	1000000

ER
serial_close(ID portid, BOOL flush)
{
	SPCB	*spcb;
	int	i;

	if (!(1 <= portid && portid <= NUM_PORT)) {
		return(E_PAR);		/* ݡֹΥå */
	}

	spcb = get_spcb(portid);
	if (!(spcb->init_flag)) {	/* ѤΥå */
		return(E_OBJ);
	}

	/*
	 *  ХåեΥեå
	 */
	if (flush) {
		for (i = 0; i < MAX_FLUSH_LOOP; i++) {
			if (spcb->out_write_ptr == spcb->out_read_ptr) {
				break;
			}
		}
	}

	/*
	 *  ϡɥ¸Υåȥ
	 */
	syscall(loc_cpu());
	hw_port_terminate(&(spcb->hwport));
	syscall(unl_cpu());

	spcb->init_flag = FALSE;
	return(E_OK);
}

/*
 *  եȥط
 */
#define	STOP	'\023'		/* ȥ-S */
#define	START	'\021'		/* ȥ-Q */

#define	IXOFF_STOP	64	/* STOPĤХåեꥢ */
#define	IXOFF_START	128	/* STARTĤХåեꥢ */

#define	in_buf_area(p)							\
		((spcb->in_read_ptr >= spcb->in_write_ptr) ?		\
		 (spcb->in_read_ptr - spcb->in_write_ptr) :		\
		 (spcb->in_read_ptr + SERIAL_BUFSZ - spcb->in_write_ptr))

/*
 *  桼ƥƥ롼
 */

Inline BOOL
enable_send(SPCB *spcb, char c)
{
	if (!(spcb->send_enabled)) {
		hw_port_sendstart(&(spcb->hwport));
		spcb->send_enabled = TRUE;
		if (hw_port_putready(&(spcb->hwport))) {
			hw_port_putchar(&(spcb->hwport), c);
			return(TRUE);
		}
	}
	return(FALSE);
}

/*
 *  ꥢݡȤμ
 */

static BOOL
serial_getc(SPCB *spcb, char *c)
{
	BOOL	buffer_empty;

	syscall(loc_cpu());
	*c = spcb->in_buffer[spcb->in_read_ptr];
	INC(spcb->in_read_ptr);

	if (*c == '\r' && (spcb->ioctl & IOCTL_RAW) == 0) {
		*c = '\n';
	}

	if (spcb->ixoff_stopped && (in_buf_area(spcb) > IXOFF_START)) {
		if (!enable_send(spcb, START)) {
			spcb->ixoff_send = START;
		}
		spcb->ixoff_stopped = FALSE;
	}
	buffer_empty = IN_BUFFER_EMPTY(spcb);
	syscall(unl_cpu());
	return(buffer_empty);
}

ER_UINT
serial_read(ID portid, char *buf, UINT len)
{
	SPCB		*spcb;
	BOOL		buffer_empty;
	char		c;
	unsigned int	i;

	if (sns_dpn()) {		/* ƥȤΥå */
		return(E_CTX);
	}
	if (!(0 <= portid && portid <= NUM_PORT)) {
		return(E_PAR);		/* ݡֹΥå */
	}

	spcb = get_spcb_def(portid);
	if (!(spcb->init_flag)) {	/* ѤΥå */
		return(E_OBJ);
	}
	if (len == 0) {
		return(len);
	}

	syscall(wai_sem(spcb->in_semid));
	buffer_empty = FALSE;
	for (i = 0; i < len; i++) {
		buffer_empty = serial_getc(spcb, &c);
		if ((spcb->ioctl & IOCTL_ECHO) != 0) {
			syscall(wai_sem(spcb->out_semid));
			if (!serial_putc(spcb, c)) {
				syscall(sig_sem(spcb->out_semid));
			}
		}
		*buf++ = c;
		if ((spcb->ioctl & IOCTL_RAW) != 0
				|| ((spcb->ioctl & IOCTL_CANONICAL) != 0
						&& c == '\n')) {
			len = i + 1;
			break;
		}
		if (buffer_empty && i < len - 1) {
			syscall(wai_sem(spcb->in_semid));
		}
	}
	if (!buffer_empty) {
		syscall(sig_sem(spcb->in_semid));
	}
	return(len);
}

/*
 *  ꥢݡȤؤ
 */

static BOOL
serial_putc(SPCB *spcb, char c)
{
	BOOL	buffer_full;

	if (c == '\n' && (spcb->ioctl & IOCTL_CRLF) != 0) {
		if (serial_putc(spcb, '\r')) {
			syscall(wai_sem(spcb->out_semid));
		}
	}

	syscall(loc_cpu());
	if (!(spcb->ixon_stopped) && enable_send(spcb, c)) {
		buffer_full = FALSE;
	}
	else {
		spcb->out_buffer[spcb->out_write_ptr] = c;
		INC(spcb->out_write_ptr);
		buffer_full = OUT_BUFFER_FULL(spcb);
	}
	syscall(unl_cpu());
	return(buffer_full);
}

ER_UINT
serial_write(ID portid, char *buf, UINT len)
{
	SPCB		*spcb;
	BOOL		buffer_full;
	unsigned int	i;

	if (sns_dpn()) {		/* ƥȤΥå */
		return(E_CTX);
	}
	if (!(0 <= portid && portid <= NUM_PORT)) {
		return(E_PAR);		/* ݡֹΥå */
	}

	spcb = get_spcb_def(portid);
	if (!(spcb->init_flag)) {	/* ѤΥå */
		return(E_OBJ);
	}

	syscall(wai_sem(spcb->out_semid));
	buffer_full = FALSE;
	for (i = 0; i < len; i++) {
		buffer_full = serial_putc(spcb, *buf++);
		if (buffer_full && i < len - 1) {
			syscall(wai_sem(spcb->out_semid));
		}
	}
	if (!buffer_full) {
		syscall(sig_sem(spcb->out_semid));
	}
	return(len);
}

/*
 *  ꥢݡȤ
 */
ER
serial_ioctl(ID portid, UINT ioctl)
{
	SPCB	*spcb;

	if (sns_ctx()) {		/* ƥȤΥå */
		return(E_CTX);
	}
	if (!(0 <= portid && portid <= NUM_PORT)) {
		return(E_PAR);		/* ݡֹΥå */
	}

	spcb = get_spcb_def(portid);
	if (!(spcb->init_flag)) {	/* ѤΥå */
		return(E_OBJ);
	}

	spcb->ioctl = ioctl;
	return(E_OK);
}

/*
 *  ꥢݡȳߥӥ롼
 */

void
serial_handler_in(ID portid)
{
	SPCB	*spcb;
	char	c;

	spcb = get_spcb(portid);
	if (hw_port_getready(&(spcb->hwport))) {
		c = hw_port_getchar(&(spcb->hwport));
		if ((spcb->ioctl & IOCTL_IXON) != 0 && c == STOP) {
			spcb->ixon_stopped = TRUE;
		}
		else if (((spcb->ioctl & IOCTL_IXON) != 0
					|| spcb->ixon_stopped)
				&& (c == START
					|| (spcb->ioctl & IOCTL_IXANY) != 0)) {
			spcb->ixon_stopped = FALSE;
			if (!(spcb->send_enabled)) {
				hw_port_sendstart(&(spcb->hwport));
				spcb->send_enabled = TRUE;
			}
		}
		else if (IN_BUFFER_FULL(spcb)) {
			/* Хåեեξ硤ʸΤƤ롥*/
		}
		else {
			spcb->in_buffer[spcb->in_write_ptr] = c;
			if (spcb->in_read_ptr == spcb->in_write_ptr) {
				syscall(isig_sem(spcb->in_semid));
			}
			INC(spcb->in_write_ptr);

			if ((spcb->ioctl & IOCTL_IXOFF) != 0
					&& !(spcb->ixoff_stopped)
					&& (in_buf_area(p) < IXOFF_STOP)) {
				spcb->ixoff_stopped = TRUE;
				if (!(spcb->send_enabled)) {
					hw_port_sendstart(&(spcb->hwport));
					spcb->send_enabled = TRUE;
				}
				spcb->ixoff_send = STOP;
			}
		}
	}
}

void
serial_handler_out(ID portid)
{
	SPCB	*spcb;

	spcb = get_spcb(portid);
	if (hw_port_putready(&(spcb->hwport))) {
		if (!spcb->send_enabled) {
			hw_port_sendstop(&(spcb->hwport));
		}
		else if (spcb->ixoff_send) {
			hw_port_putchar(&(spcb->hwport), spcb->ixoff_send);
			spcb->ixoff_send = 0;
		}
		else if (spcb->ixon_stopped
				|| spcb->out_read_ptr == spcb->out_write_ptr) {
			/*  */
			hw_port_sendstop(&(spcb->hwport));
			spcb->send_enabled = FALSE;
		}
		else {
			hw_port_putchar(&(spcb->hwport),
					spcb->out_buffer[spcb->out_read_ptr]);
			if (OUT_BUFFER_FULL(spcb)) {
				syscall(isig_sem(spcb->out_semid));
			}
			INC(spcb->out_read_ptr);
		}
	}
}

/*
 *  ߥϥɥ
 */

#ifdef SEPARATE_SIO_INT

void
serial_in_handler(void)
{
	hw_serial_handler_in();
}

void
serial_out_handler(void)
{
	hw_serial_handler_out();
}

#else /* SEPARATE_SIO_INT */

void
serial_handler(void)
{
	hw_serial_handler();
}

#endif /* SEPARATE_SIO_INT */
