/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 * 
 *  嵭Ԥϡʲξ˸¤ꡤܥեȥܥ
 *  եȥѤΤޤࡥʲƱˤѡʣѡ
 *  ۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥХʥꥳɤηޤϵȤ߹
 *      ѤˤϡΤ줫ξȡ
 *    (a) ѤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) Ѥη֤̤ˡˤäơ嵭Ԥ𤹤
 *        ȡ
 *  (3) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭Ԥդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥϡ
 *  ܥեȥ˴ؤơŬѲǽޤơʤݾڤԤ
 *  ʤޤܥեȥѤˤľŪޤϴŪ
 *  ʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: kernel.h,v 1.2 2001/02/23 09:46:47 takayuki Exp $
 */

#ifndef __KERNEL_H_
#define __KERNEL_H_

#include "resource.h"       // ᥤ ܥ
#include "devicemanagerCP.h"

/////////////////////////////////////////////////////////////////////////////
// CKernel
class ATL_NO_VTABLE CKernel : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CKernel, &CLSID_Kernel>,
	public IConnectionPointContainerImpl<CKernel>,
	public IKernel,
	public CProxy_IKernelEvents< CKernel >
{
public:
	CKernel();
	~CKernel();

DECLARE_REGISTRY_RESOURCEID(IDR_KERNEL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CKernel)
	COM_INTERFACE_ENTRY(IKernel)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY_IMPL(IConnectionPointContainer)
END_COM_MAP()

BEGIN_CONNECTION_POINT_MAP(CKernel)
CONNECTION_POINT_ENTRY(IID__IKernelEvents)
END_CONNECTION_POINT_MAP()


// IKernel
public:
	STDMETHOD(Write)(unsigned long address, unsigned long sz, unsigned char data[]);
	STDMETHOD(IsValid)(BOOL * valid);
	STDMETHOD(Read)(unsigned long address, unsigned long sz, unsigned char data[]);

	bool Valid;
};

#endif //__KERNEL_H_
